#!/bin/bash

## Description: Initialise the design system repo
## Usage: ds_init [flags] [args]
## Example: "ddev ds_init -b feature/header" or "ddev ds_init"
## Flags: [{"Name":"branch","Shorthand":"b","Type":"string","Usage":"Specify greenwich_base branch to check out, if blank the default branch will be used"},{"Name":"skip-checkout","Shorthand":"s","Type":"bool","Usage":"Skip the checkout and build phase of the greenwich_base repo"}]

# quick undo rm -rf web/themes/custom/greenwich_base && rm -rf repos && ddev mutagen reset && ddev composer install

REPO_URL="git@gitlab.com:rbgreenwich/dev/design_system.git"
skip_checkout=false

show_step() {
  echo '          '
  echo '          '
  echo "------------------------------------------------------"
  if [ ! -z "$1" ]; then
    echo '          '
    echo "     $1     "
  fi
  echo '          '
  echo '          '
}

has_argument() {
  [[ ("$1" == *=* && -n ${1#*=}) || (! -z "$2" && "$2" != -*) ]]
}

extract_argument() {
  echo "${2:-${1#*=}}"
}

handle_options() {
  while [ $# -gt 0 ]; do
    case $1 in
    -b | --branch*)
      if ! has_argument $@; then
        echo "No branch specified." >&2
        usage
        exit 1
      fi

      branch_name=$(extract_argument $@)

      shift
      ;;
    -s | --skip-checkout*)

      skip_checkout=true
      skip_checkout_flag=true

      shift
      ;;
    *)
      echo "Invalid option: $1" >&2
      usage
      exit 1
      ;;
    esac
    shift
  done
}

handle_options "$@"

prep_step() {
  # if you're running with mutagen we should reset because its weird and unpredictable

  mutagen_status=$(ddev mutagen status)
  mutagen_ok_status="Mutagen: ok"

  if [[ $mutagen_status == $mutagen_ok_status* ]]; then
    ddev mutagen reset
  fi

  ddev start
}

repo_remove() {
  if [ -d "${DDEV_APPROOT}/repos/design_system" ]; then
    rm -rf ${DDEV_APPROOT}/repos/design_system
    show_step "Removed repos/design_system folder"
  fi
}

repo_checkout() {
  show_step "Checking out a nice new copy"
  git clone $REPO_URL repos/design_system
}

repo_branch() {
  if [ $branch_name ]; then
    echo "Switching to specified branch"
    cd ${DDEV_APPROOT}/repos/design_system
    git fetch
    git checkout -b $branch_name origin/$branch_name
    cd ${DDEV_APPROOT}
  fi
}

repo_pre_check() {
  NODE_VERSION="$(ddev exec --dir /var/www/html/repos/design_system cat .nvmrc)"

  ddev exec --dir /var/www/html/repos/design_system nvm use --silent || nvm install $NODE_VERSION
}

repo_install() {
  sleep 10
  show_step "Install project"
  ddev exec --dir /var/www/html/repos/design_system make install
}

repo_build() {
  show_step "Build project"
  ddev ds make build-theme-greenwich
}

make_file_gitmodules() {
  if [ ! -f "${DDEV_APPROOT}/.gitmodules" ]; then
    show_step "Generate .gitmodules file"
    cat <<GITMODULESEND >.gitmodules
# This file was dynamically generated by a script
[submodule "design_system"]
    path = repos/design_system
    url = $REPO_URL
    ignore = dirty
GITMODULESEND
  fi
}

backup_theme() {
  show_step "Backup original greenwich_base theme"

  if [ -d "${DDEV_APPROOT}/repos/bkup" ]; then
    rm -rf ${DDEV_APPROOT}/repos/bkup
  fi

  mkdir -p ${DDEV_APPROOT}/repos/bkup/greenwich_base
  mv ${DDEV_APPROOT}/web/themes/custom/greenwich_base/theme ${DDEV_APPROOT}/repos/bkup/greenwich_base
  mv ${DDEV_APPROOT}/web/themes/custom/greenwich_base/patterns ${DDEV_APPROOT}/repos/bkup/greenwich_base
  ls -lah ${DDEV_APPROOT}/repos/bkup

}

symlink_theme() {
  show_step "Setup symlinks"
  # mkdir -p ${DDEV_APPROOT}/web/themes/custom/greenwich_base/theme
  # mkdir -p ${DDEV_APPROOT}/web/themes/custom/greenwich_base/patterns
  ddev exec ln -sfn ../../../../repos/design_system/src/themes/drupal/greenwich_base web/themes/custom/greenwich_base/theme
  sleep 10
  ddev exec ln -sfn ../../../../repos/design_system/dist/themes/drupal/greenwich_base web/themes/custom/greenwich_base/patterns
  ddev exec ls -lah /var/www/html/web/themes/custom/greenwich_base
}

# prep_step

echo "${DDEV_APPROOT}/repos/design_system"

if [ -d "${DDEV_APPROOT}/repos/design_system" ]; then
  ds_exists=true
fi

if [ ! "$skip_checkout_flag" ]; then
  if [ "$ds_exists" = true ]; then
    echo ""
    echo "🚨 Notice: The design_system repo already exists!"
    echo ""
    while true; do
      read -p "Do you want to DELETE and checkout a new copy of the drupal component library? (y/n) " yn
      case $yn in
      [Yy]*)
        skip_checkout=false
        break
        ;;
      [Nn]*)
        skip_checkout=true
        break
        ;;
      *) echo "Please answer yes or no." ;;
      esac
    done
  else
    echo "🥳 Notice: The design_system doesn't exist!"
  fi
fi

if [ "$skip_checkout" = false ]; then
  while true; do
    read -p "Would you like to checkout a specific branch of the design system? (y/n) " yn
    case $yn in
    [Yy]*)
      skip_branch=false
      read -p 'Please enter the branch name: ' branch_name
      break
      ;;
    [Nn]*)
      skip_branch=true
      break
      ;;
    *) echo "Please answer yes or no." ;;
    esac
  done
fi

if [ "$skip_checkout" = false ]; then
  repo_remove
  repo_checkout

  if [ "$branch_name" ]; then
    repo_branch
  fi
  repo_pre_check
  repo_install
  repo_build
fi

make_file_gitmodules

if [ -d "${DDEV_APPROOT}/repos/design_system" ]; then

  if [ ! -d "${DDEV_APPROOT}/repos/design_system/node_modules" ]; then
    repo_pre_check
    repo_install
  fi

  if [ ! -d "${DDEV_APPROOT}/repos/design_system/dist/themes/drupal/greenwich_base" ]; then
    repo_pre_check
    repo_build
  fi

fi

backup_theme
symlink_theme

ddev drush cr
